#include "stdafx.h"
#include "spltest.h"
#include "Splasher.h"
#include "MainFrm.h"
#include "spltestDoc.h"
#include "spltestView.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#endif


//Our simple derived Splash screen class, which just uses the bitmap resource IDB_SPLASH
class CMySplashWnd : public CSplashWnd
{
public:
//Constructors / Destructors
#pragma warning(suppress: 26455)
  CMySplashWnd()
  {
    //Lets use an almost opaque splash window with some "cut-out" sections in it
    SetBitmapToUse(IDB_SPLASH);
    SetDropShadow();
    SetTransparent(RGB(255, 0, 255), LWA_ALPHA, 224);
  }
  CMySplashWnd(const CMySplashWnd&) = delete;
  CMySplashWnd(CMySplashWnd&&) = delete;
  ~CMySplashWnd() = default; //NOLINT(modernize-use-override)

//Methods
  CMySplashWnd& operator=(const CMySplashWnd&) = delete;
  CMySplashWnd& operator=(CMySplashWnd&&) = delete;

protected:
  DECLARE_DYNCREATE(CMySplashWnd);
};

#pragma warning(suppress: 26409 26433 26440 26477)
IMPLEMENT_DYNCREATE(CMySplashWnd, CSplashWnd);


#pragma warning(suppress: 26433 26440)
BEGIN_MESSAGE_MAP(CSpltestApp, CWinApp) //NOLINT(clang-diagnostic-unused-local-typedef, modernize-avoid-c-arrays)
  ON_COMMAND(ID_APP_ABOUT, &CSpltestApp::OnAppAbout)
  ON_COMMAND(ID_FILE_NEW, &CWinApp::OnFileNew)
  ON_COMMAND(ID_FILE_OPEN, &CWinApp::OnFileOpen)
  ON_COMMAND(ID_FILE_PRINT_SETUP, &CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

#pragma warning(suppress: 26426)
CSpltestApp theApp;

BOOL CSpltestApp::InitInstance()
{
  /////////////////// ADDED TO SUPPORT THE SPLASH SCREEN//////////////////////
  CSplashFactory factory;
  if (!factory.Create(RUNTIME_CLASS(CMySplashWnd)))
  {
    AfxMessageBox(_T("Failed to create splash screen"), MB_OK | MB_ICONSTOP);
    return FALSE;
  }

  //Simulate some slow loading process. Your code might
  //load up some info from a file or make a network connection etc.
  Sleep(5000);

  //Usual MFC stuff
#pragma warning(suppress: 26400 26403 26409)
  auto pDocTemplate{new CSingleDocTemplate(IDR_MAINFRAME, RUNTIME_CLASS(CSpltestDoc),
                                           RUNTIME_CLASS(CMainFrame), RUNTIME_CLASS(CSpltestView))};
  AddDocTemplate(pDocTemplate);
  CCommandLineInfo cmdInfo;
  ParseCommandLine(cmdInfo);
  if (!ProcessShellCommand(cmdInfo))
    return FALSE;

  /////////////////// ADDED TO SUPPORT THE SPLASH SCREEN//////////////////////
  //call close, it will be done for you automatically when "factory" goes out
  //of scope!!.
  factory.Close();
  ////////////////////////////////////////////////////////////////////////////

  return TRUE;
}

class CAboutDlg : public CDialog
{
public:
//Constructors / Destructors
  CAboutDlg();
  CAboutDlg(const CAboutDlg&) = delete;
  CAboutDlg(CAboutDlg&&) = delete;
  ~CAboutDlg() = default; //NOLINT(modernize-use-override)

//Methods
  CAboutDlg& operator=(const CAboutDlg&) = delete;
  CAboutDlg& operator=(CAboutDlg&&) = delete;

  enum { IDD = IDD_ABOUTBOX };

protected:
  DECLARE_MESSAGE_MAP()
};

#pragma warning(suppress: 26455)
CAboutDlg::CAboutDlg() : CDialog{CAboutDlg::IDD}
{
}

#pragma warning(suppress: 26433 26440)
BEGIN_MESSAGE_MAP(CAboutDlg, CDialog) //NOLINT(clang-diagnostic-unused-local-typedef, modernize-avoid-c-arrays)
END_MESSAGE_MAP()

void CSpltestApp::OnAppAbout()
{
  CAboutDlg aboutDlg;
  aboutDlg.DoModal();
}
